<?php 

$storyid =  getFromQueryString ('story');      
$storyrecord = readDatabaseRecord($storyrecordkeys, 'data/stories/' . $storyid . '.txt');


//RETRIEVE FORM INPUT 
if ($_SERVER ["REQUEST_METHOD"] == "POST" ) {   
        
    //Check if new story - if so, create id
    $error = false;
    if (!$storyid ) {  
        if ($_POST['name']) {
            $storyid = createRecordId ($_POST['name']);        
            if ($storyid === '') {
                echo "<div class = 'error'>Unable to create record id from title</div>";
                $error = true;  
            }
            //Check if file already exists
            else if  (file_exists ('data/stories/' . $storyid . '.txt')) {                
                echo "<div class = 'error'>Story already exists</div>";              
                $error = true;
            }             
        }
        else {
            echo "</div class = 'error'>Missing story Name</div>";
            $error = true;
        }          
    }

    if (!$error ) {          

        //ASSIGN INPUT TO RECORD FIELDS
        foreach ($storyrecordkeys as $key) {         
        if (isset ($_POST[$key])) {       
            $storyrecord [$key] =  sanitizeFormInput ($_POST[$key]  );
            }
        }        
        //Check date format
        if ($storyrecord['date'] ) {        
            if (is_numeric (substr ($storyrecord['date'], 0,4))) {
                //format yyyy/mm/dd
                $month = substr ($storyrecord['date'], 5, 2);
                $day = substr ($storyrecord['date'], 8,2);        
                $year = substr ($storyrecord['date'], 0, 4);
                $storyrecord['date'] = $year . '-' . $month . '-' . $day; 
            }
            else {
                //format mm/dd/yyyy
                $month = substr ($storyrecord['date'], 0, 2);
                $day = substr ($storyrecord['date'], 3,2);        
                $year = substr ($storyrecord['date'], 6, 4);
                $storyrecord['date'] = $year . '-' . $month . '-' . $day; 
            }  
        }
        else { 
            //default current date  
            $storyrecord['date'] = date('Y-m-d');
        }

        removeMapEntries ("data/maps/tag-story-map.txt",  "", $storyid);  
        if (isset ($_POST['selected'])) {
           $selected = $_POST['selected'];  
           foreach ($selected as $tag) {               
               addMapEntry ("data/maps/tag-story-map.txt", $tag, $storyid); 
           }
       }    

        writeDatabaseRecord ($storyrecord, 'data/stories/' . $storyid . '.txt');
        removeMapEntries ('data/maps/story-author-map.txt', '', $storyid);
        addMapEntry ('data/maps/story-author-map.txt', $storyid,  $storyrecord['author']);
        removeMapEntries ('data/maps/date-story-map.txt', '', $storyid);
        addMapEntry ('data/maps/date-story-map.txt', $storyrecord['date'], $storyid);
        
    }
}

if ($storyid)   {
    echo "<h2>Edit Story</h2>";
    echo "<h3>" . $storyrecord['title'] . "</h3>";
}
else {
    echo "<h2>New Story</h2>";
    $storyrecord['date'] = date('Y-m-d');
}

?>
 
<form method='post' action='admin.php?adminpage=add-update-story&story=<?php echo $storyid;?>'> 
   <div class = 'content-column left'>    
        <?php          
       
        echo "<label for = 'title'>Title</label><br>";          
        echo "<textarea id = 'title' name = 'title' rows = '1' >" . $storyrecord['title'] . "</textarea>";

        echo "<br><br><label for = 'date' >Date</label><br>";          
        echo "<input id = 'date' type = 'date' name = 'date' value = '" . $storyrecord['date'] . "'/>";

        echo "<br><br><label for = 'text' >Text</label><br>";
        echo "<textarea id = 'text' name = 'text' rows = '10' >" . $storyrecord['text'] . "</textarea>";

        echo "<br><br><b>Author</b><br>";
        $array1 = scandir ('data/authors');
        foreach ($array1 as $item1) {
            if (substr ($item1, 0, 1) !== '.') {
                $authorid = str_replace ('.txt', '', $item1);
                $authorrecord = readDatabaseRecord ($authorrecordkeys, 'data/authors/' . $authorid . '.txt');
                if ($storyrecord['author'] === $authorid) {                   
                    echo  "<input id = '" . $authorid . "' type = 'radio' name = 'author' value = '" . $authorid . "' checked/>";
                }
                else {                 
                    echo  "<input id = '" . $authorid . "' type = 'radio' name = 'author' value = '" . $authorid . "'/>";
                }
                echo "<label for = '" . $authorid . "'>";
                echo showWords ($authorid) . "</label><br>";
            }
        }

        echo "<br><br><b>Tags</b><br>";
        $currentarray = selectMapEntries ('data/maps/tag-story-map.txt', '', $storyid);
        
        $tagarray = readArray ('data/tags.txt', ',');
        foreach ($tagarray as $tag) {
        
            if (in_array($tag,  $currentarray)) {
                echo "<input id = '" . $tag . "' class = 'checkbox' type = 'checkbox' name = 'selected[]' value = '" . $tag . "' checked />";                  
            }
            else {
                echo "<input id = '" . $tag . "'  class = 'checkbox' type = 'checkbox' name = 'selected[]' value = '" . $tag . "' />"; 
            }
            echo "<label for = '" .$tag . "'>";            
            echo showWords ($tag);            
            echo "</label>";
            echo "<br>";
        }

        echo "<br><br><input type = 'submit'  class = 'submitbutton' name = 'submit' value = 'Save' />";

        

        ?>    
  
    
</div><div class = 'sidebar-column'>
    <a class = 'adminbutton' href = 'admin.php?adminpage=dashboard'>Dashboard</a>
    <a class = 'adminbutton' href = 'index.php?page=display-story&story=<?php echo $storyid; ?>'>View</a>
    <a class = 'adminbutton' href = 'admin.php?adminpage=remove-story&story=<?php echo $storyid; ?>'>Remove</a>
</div>

<?php
echo "<br><br><b>Select Image for Story</b><br>";
$array1 = scandir ('data/images');

for ($i = 2; $i < count ($array1); $i++) {
    echo "<div class = 'input-gridcolumn'>";
    if ($storyrecord['image'] == $array1[$i] ){
        echo "<label for = '" . $i . "'> " . $array1[$i] . "</label>";
        echo  "<input id = '" . $i . "' type = 'radio' name = 'image' value = '" . $array1[$i] . "'  checked/>";
    }
    else {
       echo "<label for = '" . $i . "'> " . $array1[$i] . "</label>";
        echo  "<input id = '" . $i . "' type = 'radio' name = 'image' value = '" . $array1[$i] . "' />";
    }
    echo "<br><img  src = 'data/images/" . $array1[$i] . "' alt = 'img' >";
    echo "</div>";
}
?>
</form>

 
